#!/bin/bash
# Some Generic functions for use in the ib-check scrips.
# Created 10/26/2005

# Messages functions

if tty -s < /dev/stdout ; then TTY_OUT=1; else TTY_OUT=0 ; fi

msg-white(){
    if [[ $TTY_OUT -eq 1 ]]; then printf '\E[37;2m%s\E[0m\n' "$*"
    else printf '%s\n' "$*" ; fi
}
msg-red(){
    if [[ $TTY_OUT -eq 1 ]]; then printf '\E[31;2m%s\E[0m\n' "$*"
    else printf '%s\n' "$*" ; fi
}
msg-green(){
    if [[ $TTY_OUT -eq 1 ]]; then printf '\E[32;2m%s\E[0m\n' "$*"
    else printf '%s\n' "$*" ; fi
}
msg-blue(){
    if [[ $TTY_OUT -eq 1 ]]; then printf '\E[34;2m%s\E[0m\n' "$*"
    else printf '%s\n' "$*" ; fi
}
msg-yellow(){
    if [[ $TTY_OUT -eq 1 ]]; then printf '\E[33;2m%s\E[0m\n' "$*"
    else printf '%s\n' "$*" ; fi
}

msg-white-rv(){
    if [[ $TTY_OUT -eq 1 ]]; then printf '\E[37;2;7m%s\E[0m\n' "$*"
    else printf '%s\n' "$*" ; fi
}
msg-red-rv(){
    if [[ $TTY_OUT -eq 1 ]]; then printf '\E[31;2;7m%s\E[0m\n' "$*"
    else printf '%s\n' "$*" ; fi
}
msg-green-rv(){
    if [[ $TTY_OUT -eq 1 ]]; then printf '\E[32;2;7m%s\E[0m\n' "$*"
    else printf '%s\n' "$*" ; fi
}
msg-blue-rv(){
    if [[ $TTY_OUT -eq 1 ]]; then printf '\E[34;2;7m%s\E[0m\n' "$*"
    else printf '%s\n' "$*" ; fi
}
msg-yellow-rv(){
    if [[ $TTY_OUT -eq 1 ]]; then printf '\E[33;2;7m%s\E[0m\n' "$*"
    else printf '%s\n' "$*" ; fi
}

msg-test-all() {   # Test messages
    for n in msg-white msg-red msg-blue msg-yellow msg-white-rv msg-red-rv msg-blue-rv msg-yellow-rv ; do
        $n $n
    done
}

# msg-test-all

function ib-vstat-parse-info()
{
    # Analyze the vstat command output:
    # Get firmware version and links state, check that at least one is active.

    local host="$1"
    local ibstatus="$2"
    local rc=0

    ibfwver=$(echo "$ibstatus" | awk -F "=" '/fw_ver/{print $2}')
    port1s=$(echo "$ibstatus" | awk -F "=" '/port=/{p=$2}/port_state/&&p==1{print $2}')
    port1lid=$(echo "$ibstatus" | awk -F "=" '/port=/{p=$2}/port_lid/&&p==1{print $2}')
    port1sm=$(echo "$ibstatus" | awk -F "=" '/port=/{p=$2}/sm_lid/&&p==1{print $2}')
    port2s=$(echo "$ibstatus" | awk -F "=" '/port=/{p=$2}/port_state/&&p==2{print $2}')
    port2lid=$(echo "$ibstatus" | awk -F "=" '/port=/{p=$2}/port_lid/&&p==2{print $2}')
    port2sm=$(echo "$ibstatus" | awk -F "=" '/port=/{p=$2}/sm_lid/&&p==2{print $2}')

    msg-green "[${host}] HCA firmware version: $ibfwver"

    if [[ $port1s == PORT_ACTIVE || $port2s == PORT_ACTIVE ]]; then
	msg-green "[${host}] Found at least one IB port in ACTIVE state"
	m=msg-green
    else
	msg-red "[${host}] No Active IB port (port1: $port1s, port2: $port2s)"
	m=msg-red
        rc=1
    fi
    
    $m "[${host}] IB port1's State: $port1s, LID: $port1lid, SM LID: $port1sm"
    $m "[${host}] IB port2's State: $port2s, LID: $port2lid, SM LID: $port2sm"
    return $rc
}
